#include "bone.h"
#include "types.h"

#include <godot_cpp/core/class_db.hpp>

#include <godot_cpp/classes/global_constants.hpp>

#include <godot_cpp/variant/utility_functions.hpp>

using namespace godot;

void UltraleapBone::_bind_methods() {
    ClassDB::bind_method(D_METHOD("get_prev_joint"), &UltraleapBone::get_prev_joint);
    ClassDB::bind_method(D_METHOD("set_prev_joint", "prev_joint"), &UltraleapBone::set_prev_joint);

    ClassDB::bind_method(D_METHOD("get_next_joint"), &UltraleapBone::get_next_joint);
    ClassDB::bind_method(D_METHOD("set_next_joint", "next_joint"), &UltraleapBone::set_next_joint);

    ClassDB::bind_method(D_METHOD("get_width"), &UltraleapBone::get_width);
    ClassDB::bind_method(D_METHOD("set_width", "width"), &UltraleapBone::set_width);

    ClassDB::bind_method(D_METHOD("get_rotation"), &UltraleapBone::get_rotation);
    ClassDB::bind_method(D_METHOD("set_rotation", "rotation"), &UltraleapBone::set_rotation);

    ClassDB::add_property(
        "UltraleapBone",
        PropertyInfo(
            Variant::VECTOR3,
            "prev_joint"
        ),
        "set_prev_joint",
        "get_prev_joint"
    );

    ClassDB::add_property(
        "UltraleapBone",
        PropertyInfo(
            Variant::VECTOR3,
            "next_joint"
        ),
        "set_next_joint",
        "get_next_joint"
    );

    ClassDB::add_property(
        "UltraleapBone",
        PropertyInfo(
            Variant::FLOAT,
            "width"
        ),
        "set_width",
        "get_width"
    );

    ClassDB::add_property(
        "UltraleapBone",
        PropertyInfo(
            Variant::QUATERNION,
            "rotation"
        ),
        "set_rotation",
        "get_rotation"
    );
}

void UltraleapBone::fill_bone_data(UltraleapBone* ul_bone, LEAP_BONE* bone) {
    ul_bone->prev_joint = UltraleapTypes::ultraleap_vector3_to_godot_vector3(&bone->prev_joint);
    ul_bone->next_joint = UltraleapTypes::ultraleap_vector3_to_godot_vector3(&bone->next_joint);
    ul_bone->width = bone->width / 1000;
    ul_bone->rotation = UltraleapTypes::ultraleap_quaternion_to_godot_quaternion(&bone->rotation);
}