#ifndef ULTRALEAP_BONE_H
#define ULTRALEAP_BONE_H

#include <godot_cpp/classes/global_constants.hpp>
#include <godot_cpp/classes/ref.hpp>
#include <godot_cpp/classes/resource.hpp>

#include <godot_cpp/core/binder_common.hpp>
#include <godot_cpp/core/class_db.hpp>

#include <godot_cpp/variant/vector3.hpp>
#include <godot_cpp/variant/quaternion.hpp>

#include <LeapC.h>

using namespace godot;

class UltraleapBone : public Resource {
    GDCLASS(UltraleapBone, Resource);

public:
    Vector3 prev_joint;
    Vector3 next_joint;
    float width;
    Quaternion rotation;

    // Getters / Setters
    Vector3 get_prev_joint() { return prev_joint; }
    void set_prev_joint(Vector3 value) { prev_joint = value; }

    Vector3 get_next_joint() { return next_joint; }
    void set_next_joint(Vector3 value) { next_joint = value; }

    float get_width() { return width; }
    void set_width(float value) { width = value; }

    Quaternion get_rotation() { return rotation; }
    void set_rotation(Quaternion value) { rotation = value; }

    static void fill_bone_data(UltraleapBone* ul_bone, LEAP_BONE* bone);
protected:
    static void _bind_methods();
};

#endif
