#include "digit.h"
#include "types.h"

#include <godot_cpp/core/class_db.hpp>

#include <godot_cpp/classes/global_constants.hpp>

#include <godot_cpp/variant/utility_functions.hpp>
#include <godot_cpp/variant/vector3.hpp>
#include <godot_cpp/variant/quaternion.hpp>

#include <LeapC.h>

using namespace godot;

void UltraleapDigit::_bind_methods() {
    ClassDB::bind_method(D_METHOD("get_type"), &UltraleapDigit::get_type);
    ClassDB::bind_method(D_METHOD("set_type", "type"), &UltraleapDigit::set_type);

    ClassDB::bind_method(D_METHOD("get_metacarpal"), &UltraleapDigit::get_metacarpal);
    ClassDB::bind_method(D_METHOD("set_metacarpal", "metacarpal"), &UltraleapDigit::set_metacarpal);

    ClassDB::bind_method(D_METHOD("get_proximal"), &UltraleapDigit::get_proximal);
    ClassDB::bind_method(D_METHOD("set_proximal", "proximal"), &UltraleapDigit::set_proximal);

    ClassDB::bind_method(D_METHOD("get_intermediate"), &UltraleapDigit::get_intermediate);
    ClassDB::bind_method(D_METHOD("set_intermediate", "intermediate"), &UltraleapDigit::set_intermediate);

    ClassDB::bind_method(D_METHOD("get_distal"), &UltraleapDigit::get_distal);
    ClassDB::bind_method(D_METHOD("set_distal", "distal"), &UltraleapDigit::set_distal);

    ClassDB::bind_method(D_METHOD("get_is_extended"), &UltraleapDigit::get_is_extended);
    ClassDB::bind_method(D_METHOD("set_is_extended", "is_extended"), &UltraleapDigit::set_is_extended);

    ClassDB::add_property(
        "UltraleapDigit",
        PropertyInfo(
            Variant::INT,
            "type",
            PROPERTY_HINT_ENUM,
            "Thumb,Index,Middle,Ring,Pinky,None"
        ),
        "set_type",
        "get_type"
    );

    ClassDB::add_property(
        "UltraleapDigit",
        PropertyInfo(
            Variant::OBJECT,
            "metacarpal",
            PROPERTY_HINT_RESOURCE_TYPE,
            "UltraleapBone"
        ),
        "set_metacarpal",
        "get_metacarpal"
    );

    ClassDB::add_property(
        "UltraleapDigit",
        PropertyInfo(
            Variant::OBJECT,
            "proximal",
            PROPERTY_HINT_RESOURCE_TYPE,
            "UltraleapBone"
        ),
        "set_proximal",
        "get_proximal"
    );

    ClassDB::add_property(
        "UltraleapDigit",
        PropertyInfo(
            Variant::OBJECT,
            "intermediate",
            PROPERTY_HINT_RESOURCE_TYPE,
            "UltraleapBone"
        ),
        "set_intermediate",
        "get_intermediate"
    );

    ClassDB::add_property(
        "UltraleapDigit",
        PropertyInfo(
            Variant::OBJECT,
            "distal",
            PROPERTY_HINT_RESOURCE_TYPE,
            "UltraleapBone"
        ),
        "set_distal",
        "get_distal"
    );

    ClassDB::add_property(
        "UltraleapDigit",
        PropertyInfo(
            Variant::BOOL,
            "is_extended"
        ),
        "set_is_extended",
        "get_is_extended"
    );
}

void UltraleapDigit::fill_digit_data(UltraleapDigit* ul_digit, LEAP_DIGIT* digit) {
    ul_digit->is_extended = digit->is_extended == 1;
    
    UltraleapBone::fill_bone_data(ul_digit->metacarpal, &digit->metacarpal);
    UltraleapBone::fill_bone_data(ul_digit->proximal, &digit->proximal);
    UltraleapBone::fill_bone_data(ul_digit->intermediate, &digit->intermediate);
    UltraleapBone::fill_bone_data(ul_digit->distal, &digit->distal);
}