#ifndef ULTRALEAP_DIGIT_H
#define ULTRALEAP_DIGIT_H

#include <godot_cpp/classes/global_constants.hpp>

#include <godot_cpp/core/binder_common.hpp>
#include <godot_cpp/core/object.hpp>

#include <godot_cpp/variant/vector3.hpp>
#include <godot_cpp/variant/quaternion.hpp>

#include <LeapC.h>

#include "bone.h"

using namespace godot;

class UltraleapDigit : public Resource {
    GDCLASS(UltraleapDigit, Resource);

public:
    enum FingerType {
        Thumb,
        Index,
        Middle,
        Ring,
        Pinky,
        None
    };

    FingerType type = None;

    UltraleapBone* metacarpal = memnew(UltraleapBone);
    UltraleapBone* proximal = memnew(UltraleapBone);
    UltraleapBone* intermediate = memnew(UltraleapBone);
    UltraleapBone* distal = memnew(UltraleapBone);
    bool is_extended;

    // Getters / Setters
    FingerType get_type() { return type; }
    void set_type(FingerType value) { type = value; }

    Variant get_metacarpal() { return metacarpal_ref; }
    void set_metacarpal(Variant value) { metacarpal_ref = value; }

    Variant get_proximal() { return proximal_ref; }
    void set_proximal(Variant value) { proximal_ref = value; }

    Variant get_intermediate() { return intermediate_ref; }
    void set_intermediate(Variant value) { intermediate_ref = value; }

    Variant get_distal() { return distal_ref; }
    void set_distal(Variant value) { distal_ref = value; }

    bool get_is_extended() { return is_extended; }
    void set_is_extended(bool value) { is_extended = value; }

    static void fill_digit_data(UltraleapDigit* ul_digit, LEAP_DIGIT* digit);
protected:
    static void _bind_methods();

private:
    Ref<UltraleapBone> metacarpal_ref = Ref<UltraleapBone>(metacarpal);
    Ref<UltraleapBone> proximal_ref = Ref<UltraleapBone>(proximal);
    Ref<UltraleapBone> intermediate_ref = Ref<UltraleapBone>(intermediate);
    Ref<UltraleapBone> distal_ref = Ref<UltraleapBone>(distal);
};

VARIANT_ENUM_CAST(UltraleapDigit::FingerType);

#endif