#include "image.h"

#include <godot_cpp/core/class_db.hpp>

#include <godot_cpp/classes/global_constants.hpp>

#include <godot_cpp/variant/utility_functions.hpp>

using namespace godot;

void UltraleapImage::_bind_methods() {
    ClassDB::bind_method(D_METHOD("get_data"), &UltraleapImage::get_data);
}

void UltraleapImage::fill_images_data(Ref<UltraleapImage> left, Ref<UltraleapImage> right, const LEAP_IMAGE* images) {
    uint32_t width = images->properties.width;
    uint32_t height = images->properties.height;

    if (images->data == nullptr) {
        UtilityFunctions::print("Oops null pointer for the image");
        return;
    }

    PackedInt64Array temp_left = PackedInt64Array();
    PackedInt64Array temp_right = PackedInt64Array();

    uint32_t tot_pixels = height * width;

    for (uint32_t i = 0; i < tot_pixels / 8; i++) {
        uint64_t* data_left = (uint64_t*)((uint8_t*)images->data + images->offset);
        uint64_t* data_right = (uint64_t*)((uint8_t*)(images + 1)->data + (images + 1)->offset);
        uint64_t pixel_left = data_left[i];
        uint64_t pixel_right = data_right[i];
        temp_left.push_back(pixel_left);
        temp_right.push_back(pixel_right);
    }

    left->data = temp_left.to_byte_array();
    right->data = temp_right.to_byte_array();
}