#include "types.h"

#include <godot_cpp/classes/global_constants.hpp>

#include <godot_cpp/core/binder_common.hpp>

#include <godot_cpp/variant/utility_functions.hpp>

using namespace godot;

void UltraleapTypes::_bind_methods() {
    BIND_ENUM_CONSTANT(Right);
    BIND_ENUM_CONSTANT(Left);

    BIND_ENUM_CONSTANT(Desktop);
    BIND_ENUM_CONSTANT(HMD);
    BIND_ENUM_CONSTANT(Screentop);
}

Vector3 UltraleapTypes::ultraleap_vector3_to_godot_vector3(LEAP_VECTOR* vector) {
    return Vector3(
        vector->x / 1000,
        vector->y / 1000,
        vector->z / 1000
    );
}

Quaternion UltraleapTypes::ultraleap_quaternion_to_godot_quaternion(LEAP_QUATERNION* quaternion) {
    return Quaternion(
        quaternion->x,
        quaternion->y,
        quaternion->z,
        quaternion->w
    );
}