#ifndef ULTRALEAP_TYPES_H
#define ULTRALEAP_TYPES_H

#include <godot_cpp/classes/global_constants.hpp>
#include <godot_cpp/classes/ref.hpp>
#include <godot_cpp/classes/resource.hpp>

#include <godot_cpp/core/binder_common.hpp>

#include <godot_cpp/variant/utility_functions.hpp>

#include <LeapC.h>

using namespace godot;

class UltraleapTypes : public Resource {
    GDCLASS(UltraleapTypes, Resource);

public:
    enum Chirality {
        Left,
        Right
    };

    enum TrackingMode {
        Desktop,
        HMD,
        Screentop
    };

    static Vector3 ultraleap_vector3_to_godot_vector3(LEAP_VECTOR* vector);
    static Quaternion ultraleap_quaternion_to_godot_quaternion(LEAP_QUATERNION* quaternion);

protected:
    static void _bind_methods();
};

VARIANT_ENUM_CAST(UltraleapTypes::Chirality);
VARIANT_ENUM_CAST(UltraleapTypes::TrackingMode);

#endif